﻿Imports SolidWorks.Interop.sldworks
Imports SolidWorks.Interop.swconst
Imports SolidWorks.Interop.swpublished
Imports System.Runtime.InteropServices

<Guid("8112a94e-a954-4c41-9128-8ef85797440b")> <ComVisible(True)>
Public Class Main
    Implements SwAddin

    Shared _app As SldWorks

    Friend Shared ReadOnly Property App As SldWorks
        Get
            Return _app
        End Get
    End Property

    Public Function ConnectToSW(ThisSW As Object, Cookie As Integer) As Boolean Implements ISwAddin.ConnectToSW
        _app = ThisSW
        CreateUI(Cookie)
        Return True
    End Function

    Public Function DisconnectFromSW() As Boolean Implements ISwAddin.DisconnectFromSW
        RemoveUI()
        Marshal.ReleaseComObject(_app)
        GC.Collect()
        GC.WaitForPendingFinalizers()
        GC.Collect()
        GC.WaitForPendingFinalizers()
        Return True
    End Function

    <ComRegisterFunction()>
    Private Shared Sub RegisterFunction(t As Type)
        Dim hklm As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.LocalMachine
        Dim hkcu As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser
        Dim keyname As String = "SOFTWARE\SolidWorks\Addins\{" + t.GUID.ToString() + "}"
        Dim addinkey As Microsoft.Win32.RegistryKey = hklm.CreateSubKey(keyname)
        addinkey.SetValue(Nothing, 1)
        addinkey.SetValue("Description", "Just a basic addin")
        addinkey.SetValue("Title", "Basic Addin")
        keyname = "Software\SolidWorks\AddInsStartup\{" + t.GUID.ToString() + "}"
        addinkey = hkcu.CreateSubKey(keyname)
        addinkey.SetValue(Nothing, 1)
    End Sub

    <ComUnregisterFunction()>
    Private Shared Sub UnregisterFunction(t As Type)
        Dim hkcu As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser
        Dim keyname As String = "SOFTWARE\SolidWorks\AddinsStartup\{" + t.GUID.ToString() + "}"
        hkcu.DeleteSubKey(keyname)
        Dim hklm As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.LocalMachine
        keyname = "SOFTWARE\SolidWorks\Addins\{" + t.GUID.ToString() + "}"
        hklm.DeleteSubKey(keyname)
    End Sub

    Sub CreateUI(cookie As Integer)
        App.SetAddinCallbackInfo2(0, Me, cookie)

        App.AddMenu(swDocumentTypes_e.swDocNONE, "My Tools", -1)
        App.AddMenuItem4(swDocumentTypes_e.swDocNONE, cookie, "Do Some Work@My Tools", -1, "MenuCommands(Do Some Work)", Nothing, Nothing, Nothing)
        App.AddMenuItem4(swDocumentTypes_e.swDocNONE, cookie, "About@My Tools", -1, "MenuCommands(About)", Nothing, Nothing, Nothing)
    End Sub

    Sub RemoveUI()
        App.RemoveMenu(swDocumentTypes_e.swDocNONE, "Acme Tools", Nothing)
    End Sub

    Sub MenuCommands(data As String)
        Select Case data
            Case "Do Some Work"
                App.SendMsgToUser("Work is being done")
            Case "About"
                App.SendMsgToUser("Written by CADSharp LLC")
        End Select
    End Sub

End Class